#include <avr/interrupt.h>
#include "main.h"
#include "keys.h"

///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed. Each pressed key is reported
// only once
//
uint8_t get_key_press( uint8_t key_mask )
{
  cli();                                    // read and clear atomic !
  key_mask &= key_press;                    // read key(s)
  key_press ^= key_mask;                    // clear key(s)
  sei();
  return key_mask;
}
 
///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed long enough such that the
// key repeat functionality kicks in. After a small setup delay
// the key is reported beeing pressed in subsequent calls
// to this function. This simulates the user repeadiately
// pressing and releasing the key.
//
uint8_t get_key_rpt( uint8_t key_mask )
{
  cli();                                    // read and clear atomic !
  key_mask &= key_rpt;                      // read key(s)
  key_rpt ^= key_mask;                      // clear key(s)
  sei();
  return key_mask;
}
 
///////////////////////////////////////////////////////////////////
//


