#if defined (__AVR_ATmega32__) || defined (__AVR_ATmega644P__)
    #define KEY_PORT        PORTB
    #define KEY_DIR         DDRB
    #define KEY_PIN         PINB
    #define KEY0            (1 << PB2)
    #define KEY1            (1 << PB3)
    #define KEY2            (1 << PB4)
#elif defined (__AVR_ATmega8__) || defined (__AVR_ATmega168__)
    #define KEY_PORT        PORTB
    #define KEY_DIR         DDRB
    #define KEY_PIN         PINB
    #define KEY1            (1 << PB0)
    #define KEY0            (1 << PB1)
    #define KEY2            (1 << PB2)
#else
#  error "processor type not defined in keys.h"
#endif

#define ALL_KEYS        (KEY0 | KEY1 | KEY2)
#define REPEAT_MASK     (KEY0 | KEY1)       // repeat: key0, key1
#define REPEAT_START    160                 // after ??ms
#define REPEAT_NEXT     20                  // every ??ms

volatile unsigned char key_state;           // debounced key state:
                                            // bit = 1: key pressed
volatile unsigned char key_press;           // key press detect
volatile unsigned char key_rpt;             // key long press and repeat

uint8_t get_key_press( uint8_t );
uint8_t get_key_rpt( uint8_t );
//inline void process_keys( void );
